config/routes.rb
Rails.application.routes.draw do
  resources :contacts
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
root to: "static_pages#index"
get 'sobre', to: 'static_pages#sobre'
get 'contato', to: 'static_pages#contato'

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/contact.rb
class Contact < ApplicationRecord
end

app/models/user.rb
class User < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/contacts_controller.rb
class ContactsController < ApplicationController
  before_action :set_contact, only: %i[ show edit update destroy ]

  # GET /contacts or /contacts.json
  def index
    @contacts = Contact.all
  end

  # GET /contacts/1 or /contacts/1.json
  def show
  end

  # GET /contacts/new
  def new
    @contact = Contact.new
  end

  # GET /contacts/1/edit
  def edit
  end

  # POST /contacts or /contacts.json
  def create
    @contact = Contact.new(contact_params)

    respond_to do |format|
      if @contact.save
        format.html { redirect_to @contact, notice: "Contact was successfully created." }
        format.json { render :show, status: :created, location: @contact }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @contact.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /contacts/1 or /contacts/1.json
  def update
    respond_to do |format|
      if @contact.update(contact_params)
        format.html { redirect_to @contact, notice: "Contact was successfully updated." }
        format.json { render :show, status: :ok, location: @contact }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @contact.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /contacts/1 or /contacts/1.json
  def destroy
    @contact.destroy
    respond_to do |format|
      format.html { redirect_to contacts_url, notice: "Contact was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_contact
      @contact = Contact.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def contact_params
      params.require(:contact).permit(:name, :phone)
    end
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController

    def index
        @nome = "Felipe"
    end

    def sobre
    end

    def contato
    end


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/contacts_helper.rb
module ContactsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/contacts/_form.html.erb
<%= form_with(model: contact) do |form| %>
  <% if contact.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(contact.errors.count, "error") %> prohibited this contact from being saved:</h2>

      <ul>
        <% contact.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :phone %>
    <%= form.text_field :phone %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/contacts/edit.html.erb
<h1>Editing Contact</h1>

<%= render 'form', contact: @contact %>

<%= link_to 'Show', @contact %> |
<%= link_to 'Back', contacts_path %>

app/views/contacts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Contacts</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Phone</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @contacts.each do |contact| %>
      <tr>
        <td><%= contact.name %></td>
        <td><%= contact.phone %></td>
        <td><%= link_to 'Show', contact %></td>
        <td><%= link_to 'Edit', edit_contact_path(contact) %></td>
        <td><%= link_to 'Destroy', contact, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Contact', new_contact_path %>

app/views/contacts/new.html.erb
<h1>New Contact</h1>

<%= render 'form', contact: @contact %>

<%= link_to 'Back', contacts_path %>

app/views/contacts/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @contact.name %>
</p>

<p>
  <strong>Phone:</strong>
  <%= @contact.phone %>
</p>

<%= link_to 'Edit', edit_contact_path(@contact) %> |
<%= link_to 'Back', contacts_path %>

app/views/layouts/_footer.html.erb
<footer>
    <small>
    <%= link_to 'Contact List. Todos os direitos reservados.', root_path %>
    </small>

    <nav>
        <ul>
            <li>
                <%= link_to 'Sobre', sobre_path %>
            </li>
            <li>
            <%= link_to 'Contato', contato_path %>
            </li>
        </ul>
    </nav>
</footer>

app/views/layouts/_header.html.erb
<nav class="navbar navbar-inverse navbar-static-top">

  <div class="container-fluid">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#expanded-menu" aria-expanded=" false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <%= link_to 'Contact List', root_url, class: 'navbar-brand' %>
    </div>

  <!-- Conteudo exibido em telas maiores e que serao escondidos em telas menores -->
  <div class="collapse navbar-collapse" id="expanded-menu">
    <ul class="nav navbar-nav">
     
        <li class="active">
          <a href="#">Nova Conta</a>
        </li>
      
    </ul>

    <ul class="nav navbar-nav navbar-right">
     
        <li>
          <%= link_to 'Entrar', '#' %>
      </li>           

    </ul>

  </div>

  </div>

</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ContactList</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <%= render 'layouts/header' %>
  <div class="container">
    <%= yield %>

     <%= render 'layouts/footer' %>
  </div>
 

  </body>
</html>

app/views/static_pages/contato.html.erb
<h1>Contato</h1>

<p>
Entre em contato conosco <a href="www.google.com"> para saber mais.
</p>

app/views/static_pages/index.html.erb
    <div class="jumbotron">
    <h1>Contact List</h1>
        <p>
        Gerencie seus contatos em qualquer lugar!
        </p>
        <p>
        <%= link_to 'Crie Sua Conta', '#', class: 'btn btn-primary btn-lg' %>
        </p>
    </div>

app/views/static_pages/sobre.html.erb
<h1>Sobre</h1>
<p>
Criado com o intuito de aprender Ruby on rails.
</p>